// OpenGLLightView.cpp : t@C
//

#include "stdafx.h"
#include "ModelViewer.h"
#include "OpenGLLightView.h"


// COpenGLLightView

IMPLEMENT_DYNCREATE(COpenGLLightView, COpenGLTrackView)

COpenGLLightView::COpenGLLightView()
{
	m_aLightSetting[0].m_bLightEnabled = true;
	m_aLightSetting[0].m_f4LightDiffuse[0] = 1.0f;
	m_aLightSetting[0].m_f4LightDiffuse[1] = 1.0f;
	m_aLightSetting[0].m_f4LightDiffuse[2] = 1.0f;
	m_aLightSetting[0].m_f4LightSpecular[0] = 0.2f;
	m_aLightSetting[0].m_f4LightSpecular[1] = 0.2f;
	m_aLightSetting[0].m_f4LightSpecular[2] = 0.2f;
}

COpenGLLightView::~COpenGLLightView()
{
}

BEGIN_MESSAGE_MAP(COpenGLLightView, COpenGLTrackView)
END_MESSAGE_MAP()


// COpenGLLightView `

//void COpenGLLightView::OnDraw(CDC* pDC)
//{
//	CDocument* pDoc = GetDocument();
//	// TODO: `R[hɒǉĂB
//}


// COpenGLLightView ff

#ifdef _DEBUG
void COpenGLLightView::AssertValid() const
{
	COpenGLTrackView::AssertValid();
}

#ifndef _WIN32_WCE
void COpenGLLightView::Dump(CDumpContext& dc) const
{
	COpenGLTrackView::Dump(dc);
}
#endif
#endif //_DEBUG

bool COpenGLLightView::SetupLight()
{
	for( int nIndexLight = 0; nIndexLight < 4; nIndexLight++ )
	{
		if( m_aLightSetting[nIndexLight].m_bLightEnabled )
		{
			glEnable( GL_LIGHT0 + nIndexLight );
			glLightfv( GL_LIGHT0 + nIndexLight, GL_POSITION, m_aLightSetting[nIndexLight].m_f4LightPosition );
			glLightfv( GL_LIGHT0 + nIndexLight, GL_AMBIENT, m_aLightSetting[nIndexLight].m_f4LightAmbient );
			glLightfv( GL_LIGHT0 + nIndexLight, GL_DIFFUSE, m_aLightSetting[nIndexLight].m_f4LightDiffuse );
			glLightfv( GL_LIGHT0 + nIndexLight, GL_SPECULAR, m_aLightSetting[nIndexLight].m_f4LightSpecular );
			glLightfv( GL_LIGHT0 + nIndexLight, GL_SPOT_DIRECTION, m_aLightSetting[nIndexLight].m_f3LightSpotDirection );
			glLightf( GL_LIGHT0 + nIndexLight, GL_SPOT_EXPONENT, m_aLightSetting[nIndexLight].m_fLightSpotExponent );
			glLightf( GL_LIGHT0 + nIndexLight, GL_SPOT_CUTOFF, m_aLightSetting[nIndexLight].m_fLightSpotCutoff );
			glLightf( GL_LIGHT0 + nIndexLight, GL_CONSTANT_ATTENUATION, m_aLightSetting[nIndexLight].m_fLightConstantAttenuation );
			glLightf( GL_LIGHT0 + nIndexLight, GL_LINEAR_ATTENUATION, m_aLightSetting[nIndexLight].m_fLightLinearAttenuation );
			glLightf( GL_LIGHT0 + nIndexLight, GL_QUADRATIC_ATTENUATION, m_aLightSetting[nIndexLight].m_fLightQuadraticAttenuation );
		}
		else
		{
			glDisable( GL_LIGHT0 + nIndexLight );
		}
	}

	return true;
}

bool COpenGLLightView::SetupModelViewMatrix()
{
	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();

	gluLookAt( m_f3RenderingCenter[0], m_f3RenderingCenter[1], m_f3RenderingCenter[2] + 500.0,	// _
		m_f3RenderingCenter[0], m_f3RenderingCenter[1], m_f3RenderingCenter[2],			// _
		0.0, 1.0, 0.0 );	// xNg

	SetupLight();

	glMultMatrixf( (GLfloat*)m_f16ViewingTransformMatrix );	// \]if]j

	return true;
}

// COpenGLLightView bZ[W nh[
